local VERSION = tonumber(("$Revision: 40942 $"):match("%d+"))

CowTip = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceEvent-2.0", "AceConsole-2.0", "FuBarPlugin-2.0", "AceHook-2.1")
local CowTip, self = CowTip, CowTip
CowTip.version = "r" .. VERSION
CowTip.revision = VERSION
CowTip.date = ("$Date: 2007-06-20 22:08:45 -0400 (Wed, 20 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")

local SharedMedia = AceLibrary("SharedMedia-1.0")
local DogTag = AceLibrary("DogTag-1.0")

local _G = _G
local GameTooltip = _G.GameTooltip
local UIParent = _G.UIParent

CowTip:RegisterDB("CowTipDB")
CowTip:RegisterDefaults('profile', {
	lines = {
		lefts = {
			"[Name]", -- [1]
			"Guild:", -- [2]
			"Level:", -- [3]
			"Race:", -- [4]
			"Class:", -- [5]
		},
		rights = {
			"", -- [1]
			"[Guild:Angle]", -- [2]
			"[Level]", -- [3]
			"[Race]", -- [4]
			"[Class]", -- [5]
		}
	}
})

-- FuBar configuration
CowTip.hasIcon = true
CowTip.hideWithoutStandby = true
CowTip.defaultPosition = "MINIMAP"
CowTip.defaultMinimapPosition = 230
CowTip.hasNoText = true
CowTip.hasNoColor = true
CowTip.cannotDetachTooltip = true
CowTip.independentProfile = true
CowTip.blizzardTooltip = true

function CowTip:OnInitialize()
	self:RegisterChatCommand('/CowTip', '/Cow', {
		type = 'execute',
		func = function()
			self:OpenMenu()
		end
	})
end

function CowTip:OnEnable()
--	self:HookScript(GameTooltip, "OnShow", "GameTooltip_OnShow")
--	self:HookScript(GameTooltip, "OnHide", "GameTooltip_OnHide")
	self:HookScript(GameTooltip, "OnTooltipSetUnit", "GameTooltip_OnTooltipSetUnit")
end

function CowTip:GameTooltip_OnTooltipSetUnit(GameTooltip, ...)
--	self.hooks[this].OnTooltipSetUnit(GameTooltip, unit, ...)
	
	local name, unit = GameTooltip:GetUnit()
	local mouseover = unit == "mouseover"
	
	GameTooltip:ClearLines()
	local db = self.db.profile.lines
	local lefts, rights = db.lefts, db.rights
	for i = 1, #lefts do
		local left, right = lefts[i], rights[i]
		local left_ev, right_ev
		if left == "" then
			left = nil
		else
			left_ev = DogTag:Evaluate(unit, left)
			if left_ev == "" then
				left = nil
				left_ev = nil
			end
		end
		if right == "" then
			right = nil
		else
			right_ev = DogTag:Evaluate(unit, right)
			if right_ev == "" then
				right = nil
				right_ev = nil
			end
		end
		if right then
			GameTooltip:AddDoubleLine(left_ev or '', right_ev)
			local leftFS = _G["GameTooltipTextLeft" .. i]
			local rightFS = _G["GameTooltipTextRight" .. i]
			DogTag:RegisterFontString(leftFS, GameTooltip, unit, left or '')
			DogTag:RegisterFontString(rightFS, GameTooltip, unit, right)
		elseif left then
			GameTooltip:AddLine(left_ev)
			local leftFS = _G["GameTooltipTextLeft" .. i]
			DogTag:RegisterFontString(leftFS, GameTooltip, unit, left)
		end
	end
end
--[[
function CowTip:GameTooltip_OnShow(this, ...)
	self.hooks[this].OnShow(this, ...)
	
	AceLibrary("AceConsole-2.0"):Print("OnShow")
end

function CowTip:GameTooltip_OnHide(this, ...)
	self.hooks[this].OnHide(this, ...)
	
	AceLibrary("AceConsole-2.0"):Print("OnHide")
end
]]
CowTip.options = {
	type = 'group',
	handler = CowTip,
	args = {
		
	}
}
CowTip.OnMenuRequest = CowTip.options

function CowTip:OnTooltipUpdate()
	GameTooltip:AddLine("CowTip")
	--[[
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine(LOCKED .. ":", (self.db.profile.settings.locked and YES or NO), 1, 1, 0, 1, 1, 1)
	local text
	if configMode == "solo" then
		text = L["Solo"]
	elseif configMode == "party" then
		text = L["Party"]
	elseif configMode == "raid" then
		text = L["Raid"]
	else
		text = L["Off"]
	end
	GameTooltip:AddDoubleLine(L["Configuration mode"] .. ":", text, 1, 1, 0, 1, 1, 1)
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine(L["|cffffff00Click|r to lock/unlock unit frames."], 0.2, 1, 0.2)
	GameTooltip:AddLine(L["|cffffff00Shift-Click|r to change configuration mode."], 0.2, 1, 0.2)
	GameTooltip:AddLine(L["|cffffff00Right-Click|r to change settings."], 0.2, 1, 0.2)
	]]
end
